require 'spec_helper'

describe 'resource_facts' do
  context 'supported operating systems' do
    on_supported_os.each do |os, facts|
      context "on #{os}" do
        let(:facts) do
          facts
        end

        context "resource_facts class without any parameters" do
          let(:params) {{ }}

          it { is_expected.to compile.with_all_deps }

          it { is_expected.to contain_class('resource_facts::params') }
          it { is_expected.to contain_class('resource_facts::install').that_comes_before('resource_facts::config') }
          it { is_expected.to contain_class('resource_facts::config') }
          it { is_expected.to contain_class('resource_facts::service').that_subscribes_to('resource_facts::config') }

          it { is_expected.to contain_service('resource_facts') }
          it { is_expected.to contain_package('resource_facts').with_ensure('present') }
        end
      end
    end
  end

  context 'unsupported operating system' do
    describe 'resource_facts class without any parameters on Solaris/Nexenta' do
      let(:facts) {{
        :osfamily        => 'Solaris',
        :operatingsystem => 'Nexenta',
      }}

      it { expect { is_expected.to contain_package('resource_facts') }.to raise_error(Puppet::Error, /Nexenta not supported/) }
    end
  end
end
